// #autoload
// #name = TeamAssetFinder
// #config = TeamAssetOptions
// #category = ilys' Scripts
// #include = support/callback.cs
// #include = support/mission_callbacks.cs
// #include = support/team_tracker.cs
// #include = support/player_support.cs
$TeamAssetFinder::Show = 1;
$TeamAssetFinder::Trans = 0;
$TeamAssetFinder::SelectedRISOption = 0;
$TeamAssetFinder::SelectedClampOption = 0;
$TeamAssetFinder::SelectedSpikeOption = 0;
$TeamAssetFinder::SelectedPulseOption = 0;
$TeamAssetFinder::SelectedMotionOption = 0;
$TeamAssetFinder::SelectedCameraOption = 0;
$TeamAssetFinder::TeamStatusMessage = 0;
$TeamAssetFinder::TeamGensDownMessage = 0;
$TeamAssetFinder::CustomRISNameText = "";
$TeamAssetFinder::CustomClampNameText = "";
$TeamAssetFinder::CustomSpikeNameText = "";
$TeamAssetFinder::CustomPulseNameText = "";
$TeamAssetFinder::CustomMotionNameText = "";
$TeamAssetFinder::CustomCameraNameText = "";
$TeamAssetFinder::TeamStatusMessageText = "Repair our turrets!";
$TeamAssetFinder::TeamGensDownMessageText = "Repair our generators!";
$TeamAssetFinder::AutoWPAssets = 0;
$TeamAssetFinder::ToggleDeps = 0;
$RISDeployed = 0;
$SpikeDeployed = 0;
$ClampDeployed = 0;
$DPuDeployed = 0;
$DMoDeployed = 0;
$DCaDeployed = 0;
if(isFile("prefs/TeamAssetFinder.cs")) exec("prefs/TeamAssetFinder.cs");
package TeamAssetFinder
{
	function clientCmdTaskInfo(%client, %aiObjtive, %team, %description, %targetName)
	{
		if($ItemUpdate)
		{
			if(%targetName $= "Deployable Station")
			{
				if($TeamAssetFinder::ToggleDeps == 0 || $TeamAssetFinder::ToggleDeps == 1 || $TeamAssetFinder::ToggleDeps == 2 || $TeamAssetFinder::ToggleDeps == 3 || $TeamAssetFinder::ToggleDeps == 5) %createWP = 1;
				for(%i = 0; %i < $clientwaypoints.getCount(); %i++)
				{
					if($clientwaypoints.getObject(%i).invID == $ID) %createWP = 0;
				}
				if($TeamAssetFinder::ShortRISNames) %name = "RIS";
				else if($TeamAssetFinder::LongRISNames) %name = %targetName;
				else %name = $TeamAssetFinder::CustomRISNameText;
				if(%createWP)
				{
					%target = createClientTarget($ID);
					%target.createWaypoint(%name);
					%target.invwaypoint = true;
					%target.invID = $ID;
					$ClientWaypoints.add(%target);
				}
				$RISDeployed++;
			}
			else if(%targetName $= "Spider Clamp Turret")
			{
				if($TeamAssetFinder::ToggleDeps == 0 || $TeamAssetFinder::ToggleDeps == 1 || $TeamAssetFinder::ToggleDeps == 2 || $TeamAssetFinder::ToggleDeps == 4 || $TeamAssetFinder::ToggleDeps == 6) %createWP = 1;
				for(%i = 0; %i < $clientwaypoints.getCount(); %i++)
				{
					if($clientwaypoints.getObject(%i).ClampID == $ID) %createWP = 0;
				}
				if($TeamAssetFinder::ShortClampNames) %name = "Clamp";
				else if($TeamAssetFinder::LongClampNames) %name = %targetName;
				else %name = $TeamAssetFinder::CustomClampNameText;
				if(%createWP)
				{
					%target = createClientTarget($ID);
					%target.createWaypoint(%name);
					%target.turretwaypoint = true;
					%target.ClampID = $ID;
					$ClientWaypoints.add(%target);
				}
				$ClampDeployed++;
			}
			else if(%targetName $= "Landspike Turret")
			{
				if($TeamAssetFinder::ToggleDeps == 0 || $TeamAssetFinder::ToggleDeps == 1 || $TeamAssetFinder::ToggleDeps == 3 || $TeamAssetFinder::ToggleDeps == 4 || $TeamAssetFinder::ToggleDeps == 7) %createWP = 1;
				for(%i = 0; %i < $clientwaypoints.getCount(); %i++)
				{
					if($clientwaypoints.getObject(%i).SpikeID == $ID) %createWP = 0;
				}
				if($TeamAssetFinder::ShortSpikeNames) %name = "Spike";
				else if($TeamAssetFinder::LongSpikeNames) %name = %targetName;
				else %name = $TeamAssetFinder::CustomSpikeNameText;
				if(%createWP)
				{
					%target = createClientTarget($ID);
					%target.createWaypoint(%name);
					%target.turretwaypoint = true;
					%target.SpikeID = $ID;
					$ClientWaypoints.add(%target);
				}
				$SpikeDeployed++;
			}
			else if(%targetName $= "Deployable Pulse Sensor")
			{
				if($TeamAssetFinder::ToggleDeps == 0 || $TeamAssetFinder::ToggleDeps == 8) %createWP = 1;
				for(%i = 0; %i < $clientwaypoints.getCount(); %i++)
				{
					if($clientwaypoints.getObject(%i).PulseID == $ID) %createWP = 0;
				}
				if($TeamAssetFinder::ShortPulseNames) %name = "Pulse";
				else if($TeamAssetFinder::LongPulseNames) %name = %targetName;
				else %name = $TeamAssetFinder::CustomPulseNameText;
				if(%createWP)
				{
					%target = createClientTarget($ID);
					%target.createWaypoint(%name);
					%target.pulsewaypoint = true;
					%target.PulseID = $ID;
					$ClientWaypoints.add(%target);
				}
				$DPuDeployed++;
			}
			else if(%targetName $= "Deployable Motion Sensor")
			{
				if($TeamAssetFinder::ToggleDeps == 0 || $TeamAssetFinder::ToggleDeps == 9) %createWP = 1;
				for(%i = 0; %i < $clientwaypoints.getCount(); %i++)
				{
					if($clientwaypoints.getObject(%i).MotionID == $ID) %createWP = 0;
				}
				if($TeamAssetFinder::ShortMotionNames) %name = "Motion";
				else if($TeamAssetFinder::LongMotionNames) %name = %targetName;
				else %name = $TeamAssetFinder::CustomMotionNameText;
				if(%createWP)
				{
					%target = createClientTarget($ID);
					%target.createWaypoint(%name);
					%target.motionwaypoint = true;
					%target.MotionID = $ID;
					$ClientWaypoints.add(%target);
				}
				$DMoDeployed++;
			}
			else if(%targetName $= "Deployed Camera")
			{
				if($TeamAssetFinder::ToggleDeps == 0 || $TeamAssetFinder::ToggleDeps == 10) %createWP = 1;
				for(%i = 0; %i < $clientwaypoints.getCount(); %i++)
				{
					if($clientwaypoints.getObject(%i).CameraID == $ID) %createWP = 0;
				}
				if($TeamAssetFinder::ShortCameraNames) %name = "Camera";
				else if($TeamAssetFinder::LongCameraNames) %name = %targetName;
				else %name = $TeamAssetFinder::CustomCameraNameText;
				if(%createWP)
				{
					%target = createClientTarget($ID);
					%target.createWaypoint(%name);
					%target.camerawaypoint = true;
					%target.CameraID = $ID;
					$ClientWaypoints.add(%target);
				}
				$DCaDeployed++;
			}
			$ItemUpdate = 0;
		}
		else if($ControlUpdate)
		{
			if(%targetName $= "Spider Clamp Turret")
			{
				if($TeamAssetFinder::ShortClampNames) %name = "Clamp";
				else if($TeamAssetFinder::LongClampNames) %name = %targetName;
				else %name = $TeamAssetFinder::CustomClampNameText;
				%target = createClientTarget($ID);
				%target.createWaypoint(%name@" needs repairs");
				%target.turretwaypoint = true;
				$ClientWaypoints.add(%target);
			}
			else if(%targetName $= "Landspike Turret")
			{
				if($TeamAssetFinder::ShortSpikeNames) %name = "Spike";
				else if($TeamAssetFinder::LongSpikeNames) %name = %targetName;
				else %name = $TeamAssetFinder::CustomSpikeNameText;
				%target = createClientTarget($ID);
				%target.createWaypoint(%name@" needs repairs");
				%target.turretwaypoint = true;
				$ClientWaypoints.add(%target);
			}
			else
			{
				%target = createClientTarget($ID);
				%target.createWaypoint(%targetName@" needs repairs");
				%target.turretwaypoint = true;
				$ClientWaypoints.add(%target);
			}
			$ControlUpdate = 0;
		}
		if(%client == teamtracker.myID && strstr(%description, "Repair") != -1) %description = " ";
		parent::clientCmdTaskInfo(%client, %aiObjtive, %team, %description, %targetName);
	}
	function clientCmdPotentialTask(%from, %description)
	{
		if(detag(%from) $= teamtracker.myName && strstr(%description, "Repair") != -1) return;
		parent::clientCmdPotentialTask(%from, %description);
	}
	function OptionsDlg::onWake(%this)
	{
		if (!$TeamTurretBind)
		{
			$RemapName[$RemapCount] = "Toggle Deploy WPs";
			$RemapCmd[$RemapCount]  = "ToggleDeployables";
			$RemapCount++;
			$RemapName[$RemapCount] = "Update Deployables";
			$RemapCmd[$RemapCount]  = "FindTeamDeployables";
			$RemapCount++;
			$RemapName[$RemapCount] = "Toggle AutoUpdate";
			$RemapCmd[$RemapCount]  = "ToggleAutoWP";
			$RemapCount++;
			$RemapName[$RemapCount] = "Turrets Status";
			$RemapCmd[$RemapCount]  = "TurretsStatus";
			$RemapCount++;
			$RemapName[$RemapCount] = "Clear Waypoints";
			$RemapCmd[$RemapCount]  = "ClearAllWaypoints";
			$RemapCount++;
			$TeamTurretBind = true;
		}
		parent::onWake(%this);
	}
	function quit()
	{
		export("$TeamAssetFinder::*", "prefs/TeamAssetFinder.cs", false);
		parent::quit();
	}
	function clientCmdControlObjectResponse(%ack, %info)
	{
		if($ControlUpdate)
		{
			if(!%ack)
			{
				if(strstr(%info, "not powered") != -1)
				{
					if($TeamAssetFinder::TeamStatusMessage) commandToServer('TeamMessageSent',"\c3"@$TeamAssetFinder::TeamGensDownMessageText@"~wrep.generator");
				}
				else if(strstr(%info, "Disabled") != -1 || strstr(%info, "Destroyed") != -1)
				{
					ServerConnection.sendTargetToServer($ID, "0 0 0");
					commandToServer('BuildClientTask','RepairObject',true);
					commandToServer('SendTaskToTeam',true);
					if($TeamAssetFinder::TeamStatusMessage) commandToServer('TeamMessageSent',"\c3"@$TeamAssetFinder::TeamStatusMessageText@"~wrep.turrets");
				}
			}
			else $ControlUpdate = 0;
			commandToServer('ResetControlObject');
			return;
		}
		parent::clientCmdControlObjectResponse(%ack, %info);
	}
	function PlayGui::onWake(%this)
	{
		Callback.add(MyTeamChanged, "ClearHud");
		Callback.add(MyTeamChanged, "AutoWPAssets");
		Callback.add(MyTeamChanged, "ClearAllWaypoints");
		Callback.add(onMatchStart, "ClearHud");
		Callback.add(onMatchStart, "AutoWPAssets");
		Callback.add(onMatchStart, "ClearAllWaypoints");
		Callback.add(CallBackMsgGameOver, "ClearHud");
		Callback.add(onUserClientDrop, "ClearHud");
		Callback.add(onUserClientJoin, "ClearHud");
		parent::onWake(%this);
		if(!isObject(PlayGui)) return;
		if(isObject(TAFCountHud)) return;
		new GuiControlProfile ("TAFLGText")
		{
			fontType = "Univers Condensed";
			fontSize = 16;
			fontColor = "0 255 0";
			justify = "center";
		};
		new GuiControlProfile ("TAFLRText")
		{
			fontType = "Univers Condensed";
			fontSize = 16;
			fontColor = "255 0 0";
			justify = "center";
		};
		new ShellFieldCtrl(TAFCountHud)
		{
			horizSizing = "left";
			vertSizing = "bottom";
			extent = "135 40";
			visible = "0";
			new GuiBitmapCtrl() {
				horizSizing = "right";
				vertSizing = "bottom";
				position = "5 5";
				extent = "15 15";
				minExtent = "8 8";
				visible = "1";
				bitmap = "gui/rinv.png";
			};
			new GuiTextCtrl(TAFRIS)
			{
				profile = "TAFLGText";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "5 20";
				extent = "15 16 ";
				text = "0";
				visible = "1";
			};
			new GuiBitmapCtrl() {
				horizSizing = "right";
				vertSizing = "bottom";
				position = "20 5";
				extent = "15 15";
				minExtent = "8 8";
				visible = "1";
				bitmap = "gui/clamp.png";
			};
			new GuiTextCtrl(TAFClamp)
			{
				profile = "TAFLGText";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "20 20";
				extent = "15 16 ";
				text = "0";
				visible = "1";
			};
			new GuiBitmapCtrl() {
				horizSizing = "right";
				vertSizing = "bottom";
				position = "35 5";
				extent = "15 15";
				minExtent = "8 8";
				visible = "1";
				bitmap = "gui/spike.png";
			};
			new GuiTextCtrl(TAFSpike)
			{
				profile = "TAFLGText";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "35 20";
				extent = "15 16 ";
				text = "0";
				visible = "1";
			};
			new GuiBitmapCtrl() {
				horizSizing = "right";
				vertSizing = "bottom";
				position = "50 5";
				extent = "15 15";
				minExtent = "8 8";
				visible = "1";
				bitmap = "gui/pulse.png";
			};
			new GuiTextCtrl(TAFPulse)
			{
				profile = "TAFLGText";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "50 20";
				extent = "15 16 ";
				text = "0";
				visible = "1";
			};
			new GuiBitmapCtrl() {
				horizSizing = "right";
				vertSizing = "bottom";
				position = "65 5";
				extent = "15 15";
				minExtent = "8 8";
				visible = "1";
				bitmap = "gui/motion.png";
			};
			new GuiTextCtrl(TAFMotion)
			{
				profile = "TAFLGText";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "65 20";
				extent = "15 16 ";
				text = "0";
				visible = "1";
			};
			new GuiBitmapCtrl() {
				horizSizing = "right";
				vertSizing = "bottom";
				position = "80 5";
				extent = "15 15";
				minExtent = "8 8";
				visible = "1";
				bitmap = "gui/camera.png";
			};
			new GuiTextCtrl(TAFCamera)
			{
				profile = "TAFLGText";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "80 20";
				extent = "15 16 ";
				text = "0";
				visible = "1";
			};
			new GuiTextCtrl() {
				profile = "TAFLRText";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "100 5";
				extent = "30 16";
				text = "AUTO";
				visible = "1";
			};
			new GuiTextCtrl(AutoWPText)
			{
				profile = "TAFLGText";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "100 20";
				extent = "30 16 ";
				text = "OFF";
				visible = "1";
			};
		};
		TAFCountHud.profile = $TeamAssetFinder::Trans ? "GuiConsoleProfile" : "GuiChatBackProfile";
		TAFCountHud.visible = $TeamAssetFinder::Show;
		playGui.add(TAFCountHud);
		if(isObject(HM) && isObject(HudMover)) hudmover::addhud(TAFCountHud,"TeamAssetFinder Hud");
	}
};
activatePackage(TeamAssetFinder);
function FindTeamDeployables(%val)
{
	if(!%val) return;
	if($TeamAssetFinder::AutoWPAssets) return;
	if($ItemUpdate) return;
	ClearStats();
	MakeFindItemCC();
	schedule(250,0,FindTeamDeployablesSecond);
}
function FindTeamDeployablesSecond()
{
	FindItems(DSupport);
	schedule(250*commanderTree.getNumTargets(DSupport),0,FindItems,DTactical);
	schedule((250*commanderTree.getNumTargets(DSupport))+(250*commanderTree.getNumTargets(DTactical)),0,UpdateTAFHud);
}
function MakeFindItemCC()
{
	if(CommanderTree.getGroup() == CommanderTreeContainer.getObject(0) && canvas.getContent().getName() !$= "CommanderMapGui")
	{
		PlayGui.add(FindItemCC);
		FindItemCC.add(CommanderTree);
		CommanderTree.openCategory("DSupport",1);
		CommanderTree.openCategory("DTactical",1);
		CommanderTree.openCategory("Tactical",1);
		commandToServer('ScopeCommanderMap', true);
	}
}
function KillFindItemCC()
{
	if(CommanderTree.getGroup() == FindItemCC.getID())
	{
		PlayGui.remove(FindItemCC);
		CommanderTreeContainer.getObject(0).add(CommanderTree);
		commandToServer('ScopeCommanderMap', false);
	}
}
function FindItems(%item)
{
	$ItemUpdate = 1;
	$MAX_OUTSTANDING_TASKS = 512;
	$ID = commanderTree.getTarget(%item,$SpamID);
	ServerConnection.sendTargetToServer($ID, "0 0 0");
	commandToServer('BuildClientTask','RepairObject',false);
	commandToServer('SendTaskToClient',PlayerList.getMyID(), false);
	$SpamID++;
	if($SpamID < commanderTree.getNumTargets(%item)) schedule(250,0,FindItems,%item);
	else $SpamID = 0;
}
function ToggleAutoWP(%val)
{
	if(%val)
	{
		$TeamAssetFinder::AutoWPAssets = !$TeamAssetFinder::AutoWPAssets;
		AutoWPText.setValue($TeamAssetFinder::AutoWPAssets ? "ON" : "OFF");
		if($TeamAssetFinder::AutoWPAssets)
		{
			clientCmdBottomPrint("AutoWPAssets is now: On", 2, 1);
			ClearAllWaypoints(1);
			AutoWPAssets();
		}
		else
		{
			clientCmdBottomPrint("AutoWPAssets is now: Off", 2, 1);
			ClearAllWaypoints(1);
			cancel($AutoWPAssetSchedule);
		}
	}
}
function ToggleDeployables(%val)
{
	if(%val)
	{
		$TeamAssetFinder::ToggleDeps++;
		$TeamAssetFinder::AutoWPAssets = 0;
		AutoWPText.setValue("OFF");
		ClearAllWaypoints(1);
		if($TeamAssetFinder::ToggleDeps > 10) $TeamAssetFinder::ToggleDeps = 0;
		if($TeamAssetFinder::ToggleDeps == 0) clientCmdBottomPrint("Will now waypoint:\nRIS+Clamp+Spike+Pulse+Motion+Camera", 2, 2);
		else if($TeamAssetFinder::ToggleDeps == 1) clientCmdBottomPrint("Will now waypoint:\nRIS+Clamp+Spike", 2, 2);
		else if($TeamAssetFinder::ToggleDeps == 2) clientCmdBottomPrint("Will now waypoint:\nRIS+Clamp", 2, 2);
		else if($TeamAssetFinder::ToggleDeps == 3) clientCmdBottomPrint("Will now waypoint:\nRIS+Spike", 2, 2);
		else if($TeamAssetFinder::ToggleDeps == 4) clientCmdBottomPrint("Will now waypoint:\nClamp+Spike", 2, 2);
		else if($TeamAssetFinder::ToggleDeps == 5) clientCmdBottomPrint("Will now waypoint:\nRIS", 2, 2);
		else if($TeamAssetFinder::ToggleDeps == 6) clientCmdBottomPrint("Will now waypoint:\nClamp", 2, 2);
		else if($TeamAssetFinder::ToggleDeps == 7) clientCmdBottomPrint("Will now waypoint:\nSpike", 2, 2);
		else if($TeamAssetFinder::ToggleDeps == 8) clientCmdBottomPrint("Will now waypoint:\nPulse", 2, 2);
		else if($TeamAssetFinder::ToggleDeps == 9) clientCmdBottomPrint("Will now waypoint:\nMotion", 2, 2);
		else if($TeamAssetFinder::ToggleDeps == 10) clientCmdBottomPrint("Will now waypoint:\nCamera", 2, 2);
	}
}
function AutoWPAssets()
{
	cancel($AutoWPAssetSchedule);
	AutoWPText.setValue($TeamAssetFinder::AutoWPAssets ? "ON" : "OFF");
	if(!$TeamAssetFinder::AutoWPAssets) return;
	if($ItemUpdate) return;
	if(teamtracker.friendlyteamid == 0) return;
	ClearStats();
	MakeFindItemCC();
	schedule(250,0,AutoWPAssetsSecond);
}
function AutoWPAssetsSecond()
{
	FindItems(DSupport);
	schedule(250*commanderTree.getNumTargets(DSupport),0,FindItems,DTactical);
	schedule((250*commanderTree.getNumTargets(DTactical))+(250*commanderTree.getNumTargets(DSupport)),0,UpdateTAFHud);
	$AutoWPAssetSchedule = schedule((250*commanderTree.getNumTargets(DTactical))+(250*commanderTree.getNumTargets(DSupport))+500,0,AutoWPAssets);
}
function TurretsStatus(%val)
{
	if(!%val) return;
	if($TeamAssetFinder::AutoWPAssets) return;
	if($ControlUpdate) return;
	if($ItemUpdate) return;
	ClearAllWaypoints(1);
	MakeFindItemCC();
	schedule(250,0,TurretsStatusSecond);
}
function TurretsStatusSecond()
{
	ControlItems(DTactical);
	schedule(250*commanderTree.getNumTargets(DTactical),0,ControlItems,Tactical);
	schedule((250*commanderTree.getNumTargets(DTactical))+(250*commanderTree.getNumTargets(Tactical)),0,KillFindItemCC);
}
function ControlItems(%item)
{
	$ControlUpdate = 1;
	$MAX_OUTSTANDING_TASKS = 512;
	$ID = commanderTree.getTarget(%item,$SpamID);
	commandToServer('ControlObject', $ID);
	$SpamID++;
	if($SpamID < commanderTree.getNumTargets(%item)) schedule(250,0,ControlItems,%item);
	else $SpamID = 0;
}
function ClearAllWaypoints(%val)
{
	if(!%val) return;
	if($ItemUpdate) return;
	ClearStats();
	for(%i = 0; %i < $clientwaypoints.getCount(); %i++)
	{
		if($clientwaypoints.getObject(%i).invwaypoint || $clientwaypoints.getObject(%i).turretwaypoint || $clientwaypoints.getObject(%i).pulsewaypoint || $clientwaypoints.getObject(%i).motionwaypoint || $clientwaypoints.getObject(%i).camerawaypoint)
		{
			$clientwaypoints.getObject(%i).delete();
			%i--;
		}
	}
}
function UpdateTAFHud()
{
	KillFindItemCC();
	TAFRIS.setValue($RISDeployed);
	TAFSpike.setValue($SpikeDeployed);
	TAFClamp.setValue($ClampDeployed);
	TAFPulse.setValue($DPuDeployed);
	TAFMotion.setValue($DMoDeployed);
	TAFCamera.setValue($DCaDeployed);
}
function ClearStats()
{
	$RISDeployed = 0;
	$SpikeDeployed = 0;
	$ClampDeployed = 0;
	$DPuDeployed = 0;
	$DMoDeployed = 0;
	$DCaDeployed = 0;
}
function ClearHud()
{
	$RISDeployed = 0;
	$SpikeDeployed = 0;
	$ClampDeployed = 0;
	$DPuDeployed = 0;
	$DMoDeployed = 0;
	$DCaDeployed = 0;
	TAFRIS.setValue($RISDeployed);
	TAFSpike.setValue($SpikeDeployed);
	TAFClamp.setValue($ClampDeployed);
	TAFPulse.setValue($DPuDeployed);
	TAFMotion.setValue($DMoDeployed);
	TAFCamera.setValue($DCaDeployed);
	$ItemUpdate = 0;
}
function TeamAssetOptions::onWake(%this)
{
	CustomRISText.setActive($TeamAssetFinder::CustomRISNames);
	RISNamePopup.setSelected($TeamAssetFinder::SelectedRISOption);
	CustomClampText.setActive($TeamAssetFinder::CustomClampNames);
	ClampNamePopup.setSelected($TeamAssetFinder::SelectedClampOption);
	CustomSpikeText.setActive($TeamAssetFinder::CustomSpikeNames);
	SpikeNamePopup.setSelected($TeamAssetFinder::SelectedSpikeOption);
	CustomPulseText.setActive($TeamAssetFinder::CustomPulseNames);
	PulseNamePopup.setSelected($TeamAssetFinder::SelectedPulseOption);
	CustomMotionText.setActive($TeamAssetFinder::CustomMotionNames);
	MotionNamePopup.setSelected($TeamAssetFinder::SelectedMotionOption);
	CustomCameraText.setActive($TeamAssetFinder::CustomCameraNames);
	CameraNamePopup.setSelected($TeamAssetFinder::SelectedCameraOption);
	CustomTurretText.setActive($TeamAssetFinder::TeamStatusMessage);
	TurretAnnounce.setValue($TeamAssetFinder::TeamStatusMessage);
	CustomGenText.setActive($TeamAssetFinder::TeamGensDownMessage);
	GenAnnounce.setValue($TeamAssetFinder::TeamGensDownMessage);
	EnableTAFHud.setValue($TeamAssetFinder::Show);
	TransTAFHud.setValue($TeamAssetFinder::Trans);
}
function RISNamePopup::onSelect(%this, %id, %text)
{
	if(%id == 0)
	{
		$TeamAssetFinder::LongRISNames = 1;
		$TeamAssetFinder::ShortRISNames = 0;
		$TeamAssetFinder::CustomRISNames = 0;
		$TeamAssetFinder::SelectedRISOption = %id;
		CustomRISText.setActive($TeamAssetFinder::CustomRISNames);
	}
	else if(%id == 1)
	{
		$TeamAssetFinder::LongRISNames = 0;
		$TeamAssetFinder::ShortRISNames = 1;
		$TeamAssetFinder::CustomRISNames = 0;
		$TeamAssetFinder::SelectedRISOption = %id;
		CustomRISText.setActive($TeamAssetFinder::CustomRISNames);
	}
	else if(%id == 2)
	{
		$TeamAssetFinder::LongRISNames = 0;
		$TeamAssetFinder::ShortRISNames = 0;
		$TeamAssetFinder::CustomRISNames = 1;
		$TeamAssetFinder::SelectedRISOption = %id;
		CustomRISText.setActive($TeamAssetFinder::CustomRISNames);
	}
}
function ClampNamePopup::onSelect(%this, %id, %text)
{
	if(%id == 0)
	{
		$TeamAssetFinder::LongClampNames = 1;
		$TeamAssetFinder::ShortClampNames = 0;
		$TeamAssetFinder::CustomClampNames = 0;
		$TeamAssetFinder::SelectedClampOption = %id;
		CustomClampText.setActive($TeamAssetFinder::CustomClampNames);
	}
	else if(%id == 1)
	{
		$TeamAssetFinder::LongClampNames = 0;
		$TeamAssetFinder::ShortClampNames = 1;
		$TeamAssetFinder::CustomClampNames = 0;
		$TeamAssetFinder::SelectedClampOption = %id;
		CustomClampText.setActive($TeamAssetFinder::CustomClampNames);
	}
	else if(%id == 2)
	{
		$TeamAssetFinder::LongClampNames = 0;
		$TeamAssetFinder::ShortClampNames = 0;
		$TeamAssetFinder::CustomClampNames = 1;
		$TeamAssetFinder::SelectedClampOption = %id;
		CustomClampText.setActive($TeamAssetFinder::CustomClampNames);
	}
}
function SpikeNamePopup::onSelect(%this, %id, %text)
{
	if(%id == 0)
	{
		$TeamAssetFinder::LongSpikeNames = 1;
		$TeamAssetFinder::ShortSpikeNames = 0;
		$TeamAssetFinder::CustomSpikeNames = 0;
		$TeamAssetFinder::SelectedSpikeOption = %id;
		CustomSpikeText.setActive($TeamAssetFinder::CustomSpikeNames);
	}
	else if(%id == 1)
	{
		$TeamAssetFinder::LongSpikeNames = 0;
		$TeamAssetFinder::ShortSpikeNames = 1;
		$TeamAssetFinder::CustomSpikeNames = 0;
		$TeamAssetFinder::SelectedSpikeOption = %id;
		CustomSpikeText.setActive($TeamAssetFinder::CustomSpikeNames);
	}
	else if(%id == 2)
	{
		$TeamAssetFinder::LongSpikeNames = 0;
		$TeamAssetFinder::ShortSpikeNames = 0;
		$TeamAssetFinder::CustomSpikeNames = 1;
		$TeamAssetFinder::SelectedSpikeOption = %id;
		CustomSpikeText.setActive($TeamAssetFinder::CustomSpikeNames);
	}
}
function PulseNamePopup::onSelect(%this, %id, %text)
{
	if(%id == 0)
	{
		$TeamAssetFinder::LongPulseNames = 1;
		$TeamAssetFinder::ShortPulseNames = 0;
		$TeamAssetFinder::CustomPulseNames = 0;
		$TeamAssetFinder::SelectedPulseOption = %id;
		CustomPulseText.setActive($TeamAssetFinder::CustomPulseNames);
	}
	else if(%id == 1)
	{
		$TeamAssetFinder::LongPulseNames = 0;
		$TeamAssetFinder::ShortPulseNames = 1;
		$TeamAssetFinder::CustomPulseNames = 0;
		$TeamAssetFinder::SelectedPulseOption = %id;
		CustomPulseText.setActive($TeamAssetFinder::CustomPulseNames);
	}
	else if(%id == 2)
	{
		$TeamAssetFinder::LongPulseNames = 0;
		$TeamAssetFinder::ShortPulseNames = 0;
		$TeamAssetFinder::CustomPulseNames = 1;
		$TeamAssetFinder::SelectedPulseOption = %id;
		CustomPulseText.setActive($TeamAssetFinder::CustomPulseNames);
	}
}
function MotionNamePopup::onSelect(%this, %id, %text)
{
	if(%id == 0)
	{
		$TeamAssetFinder::LongMotionNames = 1;
		$TeamAssetFinder::ShortMotionNames = 0;
		$TeamAssetFinder::CustomMotionNames = 0;
		$TeamAssetFinder::SelectedMotionOption = %id;
		CustomMotionText.setActive($TeamAssetFinder::CustomMotionNames);
	}
	else if(%id == 1)
	{
		$TeamAssetFinder::LongMotionNames = 0;
		$TeamAssetFinder::ShortMotionNames = 1;
		$TeamAssetFinder::CustomMotionNames = 0;
		$TeamAssetFinder::SelectedMotionOption = %id;
		CustomMotionText.setActive($TeamAssetFinder::CustomMotionNames);
	}
	else if(%id == 2)
	{
		$TeamAssetFinder::LongMotionNames = 0;
		$TeamAssetFinder::ShortMotionNames = 0;
		$TeamAssetFinder::CustomMotionNames = 1;
		$TeamAssetFinder::SelectedMotionOption = %id;
		CustomMotionText.setActive($TeamAssetFinder::CustomMotionNames);
	}
}
function CameraNamePopup::onSelect(%this, %id, %text)
{
	if(%id == 0)
	{
		$TeamAssetFinder::LongCameraNames = 1;
		$TeamAssetFinder::ShortCameraNames = 0;
		$TeamAssetFinder::CustomCameraNames = 0;
		$TeamAssetFinder::SelectedCameraOption = %id;
		CustomCameraText.setActive($TeamAssetFinder::CustomCameraNames);
	}
	else if(%id == 1)
	{
		$TeamAssetFinder::LongCameraNames = 0;
		$TeamAssetFinder::ShortCameraNames = 1;
		$TeamAssetFinder::CustomCameraNames = 0;
		$TeamAssetFinder::SelectedCameraOption = %id;
		CustomCameraText.setActive($TeamAssetFinder::CustomCameraNames);
	}
	else if(%id == 2)
	{
		$TeamAssetFinder::LongCameraNames = 0;
		$TeamAssetFinder::ShortCameraNames = 0;
		$TeamAssetFinder::CustomCameraNames = 1;
		$TeamAssetFinder::SelectedCameraOption = %id;
		CustomCameraText.setActive($TeamAssetFinder::CustomCameraNames);
	}
}
new GuiControl(FindItemCC)
{
	profile = "NewScrollCtrlProfile";
	horizSizing = "width";
	vertSizing = "height";
	position = "0 0";
	extent = "0 0";
};
new GuiControl(TeamAssetOptions) {
	profile = "GuiDefaultProfile";
	horizSizing = "center";
	vertSizing = "center";
	position = "0 0";
	extent = "365 290";
	visible = "1";
	new ShellFieldCtrl() {
		profile = "ShellFieldProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "4 4";
		extent = "355 285";
		minExtent = "16 18";
		visible = "1";
		new ShellPopupMenu(RISNamePopup) {
			profile = "ShellPopupProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 5";
			extent = "180 36";
			minExtent = "49 36";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Select Option";
			longTextBuffer = "1";
			maxLength = "255";
			maxPopupHeight = "500";
			buttonBitmap = "gui/shll_pulldown";
			rolloverBarBitmap = "gui/shll_pulldownbar_rol";
			selectedBarBitmap = "gui/shll_pulldownbar_act";
			noButtonStyle = "0";
		};
		new ShellTextEditCtrl(CustomRISText) {
			profile = "NewTextEditProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 35";
			extent = "180 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$TeamAssetFinder::CustomRISNameText";
			helpTag = "0";
			longTextBuffer = "0";
			maxLength = "255";
			historySize = "0";
			password = "0";
			IRCName = "0";
			tabComplete = "0";
			deniedSound = "InputDeniedSound";
			glowOffset = "9 9";
		};
		new ShellPopupMenu(ClampNamePopup) {
			profile = "ShellPopupProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 65";
			extent = "180 36";
			minExtent = "49 36";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Select Option";
			longTextBuffer = "1";
			maxLength = "255";
			maxPopupHeight = "500";
			buttonBitmap = "gui/shll_pulldown";
			rolloverBarBitmap = "gui/shll_pulldownbar_rol";
			selectedBarBitmap = "gui/shll_pulldownbar_act";
			noButtonStyle = "0";
		};
		new ShellTextEditCtrl(CustomClampText) {
			profile = "NewTextEditProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 95";
			extent = "180 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$TeamAssetFinder::CustomClampNameText";
			helpTag = "0";
			longTextBuffer = "0";
			maxLength = "255";
			historySize = "0";
			password = "0";
			IRCName = "0";
			tabComplete = "0";
			deniedSound = "InputDeniedSound";
			glowOffset = "9 9";
		};
		new ShellPopupMenu(SpikeNamePopup) {
			profile = "ShellPopupProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 125";
			extent = "180 36";
			minExtent = "49 36";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Select Option";
			longTextBuffer = "1";
			maxLength = "255";
			maxPopupHeight = "500";
			buttonBitmap = "gui/shll_pulldown";
			rolloverBarBitmap = "gui/shll_pulldownbar_rol";
			selectedBarBitmap = "gui/shll_pulldownbar_act";
			noButtonStyle = "0";
		};
		new ShellTextEditCtrl(CustomSpikeText) {
			profile = "NewTextEditProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 155";
			extent = "180 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$TeamAssetFinder::CustomSpikeNameText";
			helpTag = "0";
			longTextBuffer = "0";
			maxLength = "255";
			historySize = "0";
			password = "0";
			IRCName = "0";
			tabComplete = "0";
			deniedSound = "InputDeniedSound";
			glowOffset = "9 9";
		};
		new ShellPopupMenu(PulseNamePopup) {
			profile = "ShellPopupProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "175 5";
			extent = "180 36";
			minExtent = "49 36";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Select Option";
			longTextBuffer = "1";
			maxLength = "255";
			maxPopupHeight = "500";
			buttonBitmap = "gui/shll_pulldown";
			rolloverBarBitmap = "gui/shll_pulldownbar_rol";
			selectedBarBitmap = "gui/shll_pulldownbar_act";
			noButtonStyle = "0";
		};
		new ShellTextEditCtrl(CustomPulseText) {
			profile = "NewTextEditProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "175 35";
			extent = "180 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$TeamAssetFinder::CustomPulseNameText";
			helpTag = "0";
			longTextBuffer = "0";
			maxLength = "255";
			historySize = "0";
			password = "0";
			IRCName = "0";
			tabComplete = "0";
			deniedSound = "InputDeniedSound";
			glowOffset = "9 9";
		};
		new ShellPopupMenu(MotionNamePopup) {
			profile = "ShellPopupProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "175 65";
			extent = "180 36";
			minExtent = "49 36";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Select Option";
			longTextBuffer = "1";
			maxLength = "255";
			maxPopupHeight = "500";
			buttonBitmap = "gui/shll_pulldown";
			rolloverBarBitmap = "gui/shll_pulldownbar_rol";
			selectedBarBitmap = "gui/shll_pulldownbar_act";
			noButtonStyle = "0";
		};
		new ShellTextEditCtrl(CustomMotionText) {
			profile = "NewTextEditProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "175 95";
			extent = "180 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$TeamAssetFinder::CustomMotionNameText";
			helpTag = "0";
			longTextBuffer = "0";
			maxLength = "255";
			historySize = "0";
			password = "0";
			IRCName = "0";
			tabComplete = "0";
			deniedSound = "InputDeniedSound";
			glowOffset = "9 9";
		};
		new ShellPopupMenu(CameraNamePopup) {
			profile = "ShellPopupProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "175 125";
			extent = "180 36";
			minExtent = "49 36";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Select Option";
			longTextBuffer = "1";
			maxLength = "255";
			maxPopupHeight = "500";
			buttonBitmap = "gui/shll_pulldown";
			rolloverBarBitmap = "gui/shll_pulldownbar_rol";
			selectedBarBitmap = "gui/shll_pulldownbar_act";
			noButtonStyle = "0";
		};
		new ShellTextEditCtrl(CustomCameraText) {
			profile = "NewTextEditProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "175 155";
			extent = "180 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$TeamAssetFinder::CustomCameraNameText";
			helpTag = "0";
			longTextBuffer = "0";
			maxLength = "255";
			historySize = "0";
			password = "0";
			IRCName = "0";
			tabComplete = "0";
			deniedSound = "InputDeniedSound";
			glowOffset = "9 9";
		};
		new ShellToggleButton(TurretAnnounce) {
			profile = "ShellRadioProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "5 190";
			extent = "165 27";
			minExtent = "49 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$TeamAssetFinder::TeamStatusMessage";
			command = "CustomTurretText.setActive($TeamAssetFinder::TeamStatusMessage);";
			helpTag = "0";
			text = "Announce Turrets Damaged";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellTextEditCtrl(CustomTurretText) {
			profile = "NewTextEditProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 215";
			extent = "180 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$TeamAssetFinder::TeamStatusMessageText";
			helpTag = "0";
			longTextBuffer = "0";
			maxLength = "255";
			historySize = "0";
			password = "0";
			IRCName = "0";
			tabComplete = "0";
			deniedSound = "InputDeniedSound";
			glowOffset = "9 9";
		};
		new ShellToggleButton(GenAnnounce) {
			profile = "ShellRadioProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "180 190";
			extent = "165 27";
			minExtent = "49 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$TeamAssetFinder::TeamGensDownMessage";
			command = "CustomGenText.setActive($TeamAssetFinder::TeamGensDownMessage);";
			helpTag = "0";
			text = "Announce Gens Down";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellTextEditCtrl(CustomGenText) {
			profile = "NewTextEditProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "175 215";
			extent = "180 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$TeamAssetFinder::TeamGensDownMessageText";
			helpTag = "0";
			longTextBuffer = "0";
			maxLength = "255";
			historySize = "0";
			password = "0";
			IRCName = "0";
			tabComplete = "0";
			deniedSound = "InputDeniedSound";
			glowOffset = "9 9";
		};
		new ShellToggleButton(EnableTAFHud) {
			profile = "ShellRadioProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "5 250";
			extent = "165 27";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$TeamAssetFinder::Show";
			command = "TAFCountHud.visible = $TeamAssetFinder::Show;";
			helpTag = "0";
			text = "Enable Asset Count Hud";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellToggleButton(TransTAFHud) {
			profile = "ShellRadioProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "180 250";
			extent = "165 27";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$TeamAssetFinder::Trans";
			command = "TAFCountHud.profile = $TeamAssetFinder::Trans ? \"GuiConsoleProfile\" : \"GuiChatBackProfile\";";
			helpTag = "0";
			text = "Transparent Hud";
			longTextBuffer = "0";
			maxLength = "255";
		};
	};
};
RISNamePopup.add("Long RIS Names", 0);
RISNamePopup.add("Short RIS Names", 1);
RISNamePopup.add("Custom RIS Names", 2);
ClampNamePopup.add("Long Clamp Names", 0);
ClampNamePopup.add("Short Clamp Names", 1);
ClampNamePopup.add("Custom Clamp Names", 2);
SpikeNamePopup.add("Long Spike Names", 0);
SpikeNamePopup.add("Short Spike Names", 1);
SpikeNamePopup.add("Custom Spike Names", 2);
PulseNamePopup.add("Long Pulse Names", 0);
PulseNamePopup.add("Short Pulse Names", 1);
PulseNamePopup.add("Custom Pulse Names", 2);
MotionNamePopup.add("Long Motion Names", 0);
MotionNamePopup.add("Short Motion Names", 1);
MotionNamePopup.add("Custom Motion Names", 2);
CameraNamePopup.add("Long Camera Names", 0);
CameraNamePopup.add("Short Camera Names", 1);
CameraNamePopup.add("Custom Camera Names", 2);
